<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.3 of vendredi 3 décembre 2004 on jeudi 7 décembre 2006 at 6:44:57</time-stamp>


<name-space>
<name>ECEC</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>ECECCategory</category>
<attributes>
<package>ECEC</package>
</attributes>
</name-space>


<class>
<name>ECEC</name>
<environment>CormasNS.Models.ECEC</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>thePlants theForagers restrainedNumber unrestrainedNumber theUnrestrainedForagers theRestrainedForagers </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ECEC Category</category>
<attributes>
<package>ECEC</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.ECEC class</class-id> <category>description</category>

<body package="ECEC" selector="aboutIt">aboutIt
	super 
		makeAboutItDate: '03 October 2002'
		authors: #('Christophe Le Page')
		emails: #('lepage@cirad.fr')
		comments: 'Inspired from a paper by Pepper and Smuts, "Evolution of Cooperation in an Ecological Context"'</body>

<body package="ECEC" selector="lastUpdate">lastUpdate
^ 'jeudi 7 décembre 2006'	</body>

<body package="ECEC" selector="version">version
^ 'ECEC.st'	</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>init</category>

<body package="ECEC" selector="fragmentedEnv">fragmentedEnv
	self spaceModel loadEnvironmentFromFile: 'fragmented.env' withPov: #povFood.
	self initForagers.</body>

<body package="ECEC" selector="homogeneousEnv">homogeneousEnv
	self spaceModel loadEnvironmentFromFile: 'random.env' withPov: #povFood.
	self initCells:  #initLowEnergy. "allow to set the initial value of energy level. This maximum initial level may be changed by modifying the energyMaxInit class variable of Plant"
	self initForagers</body>

<body package="ECEC" selector="noAgent">noAgent
	self spaceModel loadEnvironmentFromFile: 'random.env' withPov: #povFood.
	self initCells: #initLowEnergy</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>entities creation</category>

<body package="ECEC" selector="initForagers">initForagers
"initialize 'agentsInitialNumber' foragers with restrained strategy and 'agentsInitialNumber' foragers with unrestrained strategy"
	super initAgents.
	self setRandomlyLocatedAloneAgents: RestrainedForager n: self restrainedNumber.  
	self setRandomlyLocatedAloneAgents: UnrestrainedForager n: self unrestrainedNumber</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>accessing</category>

<body package="ECEC" selector="moyPlants">moyPlants
	"Getter accessor with default value = OrderedCollection new "
	^moyPlants ifNil:[moyPlants := OrderedCollection new]</body>

<body package="ECEC" selector="moyPlants:">moyPlants: anObject 
	moyPlants := anObject</body>

<body package="ECEC" selector="moyRestrained">moyRestrained
	"Getter accessor with default value = OrderedCollection new "
	^moyRestrained ifNil:[moyRestrained := OrderedCollection new]</body>

<body package="ECEC" selector="moyRestrained:">moyRestrained: anObject 
	moyRestrained := anObject</body>

<body package="ECEC" selector="moyUnrestrained">moyUnrestrained
	"Getter accessor with default value = OrderedCollection new "
	^moyUnrestrained ifNil:[moyUnrestrained := OrderedCollection new]</body>

<body package="ECEC" selector="moyUnrestrained:">moyUnrestrained: anObject 
	moyUnrestrained := anObject</body>

<body package="ECEC" selector="repetition">repetition
	"Getter accessor with default value = 100 "
	^repetition ifNil:[repetition := 100]</body>

<body package="ECEC" selector="repetition:">repetition: anObject 
	repetition := anObject</body>

<body package="ECEC" selector="restrainedExtinction:">restrainedExtinction: anObject 
	restrainedExtinction := anObject</body>

<body package="ECEC" selector="restrainedNumber">restrainedNumber
	"Getter accessor with default value = 10 "
restrainedNumber isNil ifTrue:[restrainedNumber := 10]. 

	^restrainedNumber</body>

<body package="ECEC" selector="restrainedNumber:">restrainedNumber: anObject
	restrainedNumber := anObject</body>

<body package="ECEC" selector="restrained_Size">restrained_Size
	"Getter accessor with default value = 0 "
	^restrained_Size ifNil:[restrained_Size := 0]</body>

<body package="ECEC" selector="restrained_Size:">restrained_Size: anObject 
	restrained_Size := anObject</body>

<body package="ECEC" selector="theForagers">theForagers
^theForagers ifNil:[theForagers := IndexedSet new]</body>

<body package="ECEC" selector="theForagers:">theForagers: obj 
	theForagers := obj</body>

<body package="ECEC" selector="thePlants">thePlants
^thePlants ifNil:[thePlants := IndexedSet new]</body>

<body package="ECEC" selector="thePlants:">thePlants: x
thePlants := x</body>

<body package="ECEC" selector="theRestrainedForagers">theRestrainedForagers
^theRestrainedForagers ifNil:[theRestrainedForagers := IndexedSet new]</body>

<body package="ECEC" selector="theRestrainedForagers:">theRestrainedForagers: x
theRestrainedForagers := x</body>

<body package="ECEC" selector="theUnrestrainedForagers">theUnrestrainedForagers
^theUnrestrainedForagers ifNil:[theUnrestrainedForagers := IndexedSet new]</body>

<body package="ECEC" selector="theUnrestrainedForagers:">theUnrestrainedForagers: x
theUnrestrainedForagers := x</body>

<body package="ECEC" selector="totalExtinction:">totalExtinction: anObject 
	totalExtinction := anObject</body>

<body package="ECEC" selector="unrestrainedExtinction:">unrestrainedExtinction: anObject 
	unrestrainedExtinction := anObject</body>

<body package="ECEC" selector="unrestrainedNumber">unrestrainedNumber
	"Getter accessor with default value = 10 "
	unrestrainedNumber isNil ifTrue:[unrestrainedNumber := 10]. 
	
	^unrestrainedNumber</body>

<body package="ECEC" selector="unrestrainedNumber:">unrestrainedNumber: anObject 
	unrestrainedNumber := anObject</body>

<body package="ECEC" selector="unRestrained_Size">unRestrained_Size
	"Getter accessor with default value = 0 "
	^unRestrained_Size ifNil:[unRestrained_Size := 0]</body>

<body package="ECEC" selector="unRestrained_Size:">unRestrained_Size: anObject 
	unRestrained_Size := anObject</body>

<body package="ECEC" selector="withoutExtinction:">withoutExtinction: anObject 
	withoutExtinction := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>control</category>

<body package="ECEC" selector="step:">step: t 
	"Resource dynamics 
(because plants dynamics are independants, the activation is not mixted)"
	self stepEntities: self thePlants.
	"Agents dynamics 
(because the agents may compete for plant access, the activation is randomly mixted)"
	self stepAgentsRandomly.</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>probes</category>

<body package="ECEC" selector="plantEnergy">plantEnergy
"return the data (a number) to be plotted with the plantEnergy chart"
^self thePlants inject: 0 into: [:i :j | i + j energy]</body>

<body package="ECEC" selector="restrainedSize">restrainedSize
"return the data (a number) to be plotted with the plantEnergy chart"
^self theRestrainedForagers size</body>

<body package="ECEC" selector="unrestrainedSize">unrestrainedSize
"return the data (a number) to be plotted with the plantEnergy chart"
^self theUnrestrainedForagers size</body>
</methods>


<class>
<name>Plant</name>
<environment>CormasNS.Models.ECEC</environment>
<super>CormasNS.Kernel.SpatialEntityElement</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>energy </inst-vars>
<class-inst-vars>K r energyMaxInit </class-inst-vars>
<imports></imports>
<category>ECEC Category</category>
<attributes>
<package>ECEC</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.Plant class</class-id> <category>accessing</category>

<body package="ECEC" selector="energyMaxInit">energyMaxInit
	"Getter accessor with default value = 1 "
	^energyMaxInit ifNil:[energyMaxInit := 1]</body>

<body package="ECEC" selector="energyMaxInit:">energyMaxInit: anObject 
	energyMaxInit := anObject</body>

<body package="ECEC" selector="K">K
	"Getter accessor with default value = 10 "
	K isNil ifTrue:[K := 10]. 
	^K</body>

<body package="ECEC" selector="K:">K: anObject
	K := anObject</body>

<body package="ECEC" selector="r">r
	"Getter accessor with default value = 0.2 "
r isNil ifTrue:[r := 0.2]. 

	^r</body>

<body package="ECEC" selector="r:">r: anObject
	r := anObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>init</category>

<body package="ECEC" selector="initLowEnergy">initLowEnergy
"Set the initial value of energy level, between ]0 ; energyMaxInit] . This maximum initial level may be changed by modifying the energyMaxInit class variable of Plant"
	self energy: (Cormas random * self class energyMaxInit)</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>growth</category>

<body package="ECEC" selector="logisticGrowth">logisticGrowth
	self energy: self energy + (Cormas
				logisticIncrease: self energy
				r: self class r
				K: self class K)</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>accessing</category>

<body package="ECEC" selector="energy">energy
	"Getter accessor with default value = 0 "
	energy ifNil:[energy := 0]. 
	^energy</body>

<body package="ECEC" selector="energy:">energy: aValue
energy := aValue.
self defineVisualState; show</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>pov</category>

<body package="ECEC" selector="povFood">povFood
	^super 
		povAttribute: #energy
		min: 0
		max: self class K
		color: ColorValue green</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>control</category>

<body package="ECEC" selector="step">step
	self logisticGrowth</body>
</methods>


<class>
<name>Forager</name>
<environment>CormasNS.Models.ECEC</environment>
<super>CormasNS.Kernel.AgentLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>energy </inst-vars>
<class-inst-vars>fertilityThreshold metabolicRate harvestRate initEnergy birthRange </class-inst-vars>
<imports></imports>
<category>ECEC Category</category>
<attributes>
<package>ECEC</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.Forager class</class-id> <category>accessing</category>

<body package="ECEC" selector="birthRange">birthRange
	"Getter accessor with default value = 10 "
	^birthRange ifNil:[birthRange := 10]</body>

<body package="ECEC" selector="birthRange:">birthRange: anObject 
	birthRange := anObject</body>

<body package="ECEC" selector="fertilityThreshold">fertilityThreshold
	"Getter accessor with default value = 100 "
fertilityThreshold isNil ifTrue:[fertilityThreshold := 100]. 

	^fertilityThreshold</body>

<body package="ECEC" selector="fertilityThreshold:">fertilityThreshold: anObject
	fertilityThreshold := anObject</body>

<body package="ECEC" selector="harvestRate">harvestRate
	"Getter accessor with default value = 0 "
	harvestRate isNil ifTrue:[harvestRate := 0]. 
	
	^harvestRate</body>

<body package="ECEC" selector="harvestRate:">harvestRate: anObject 
	harvestRate := anObject</body>

<body package="ECEC" selector="initEnergy">initEnergy
	"Getter accessor with default value = 0 "
	^initEnergy ifNil:[initEnergy := 50]</body>

<body package="ECEC" selector="initEnergy:">initEnergy: anObject 
	initEnergy := anObject</body>

<body package="ECEC" selector="metabolicRate">metabolicRate
	"Getter accessor with default value = 2 "
metabolicRate isNil ifTrue:[metabolicRate := 2]. 

	^metabolicRate</body>

<body package="ECEC" selector="metabolicRate:">metabolicRate: anObject
	metabolicRate := anObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>biology</category>

<body package="ECEC" selector="die">die
	self energy &lt;= 0 ifTrue: [self dead: true].</body>

<body package="ECEC" selector="eat">eat
| qty |
	qty := self patch energy * self class harvestRate.
	self energy: self energy + qty.
	self patch energy: self patch energy - qty</body>

<body package="ECEC" selector="move">move
	(self patch neighboursMaxOf: #energy) &lt; self class metabolicRate 
		ifTrue: [self randomWalkConstrainedBy: [:c | c noOccupant]]
		ifFalse: [self walkToMaxOf: #energy constrainedBy: [:c | c noOccupant]]</body>

<body package="ECEC" selector="reproduce">reproduce
| newForager freePlace |
	self energy &gt; self class fertilityThreshold
		ifTrue: 
			[freePlace := self nearestEmptyLocation: self class birthRange.
			freePlace ifNil:[^nil].
			newForager := self newEntity: self class. 
			self energy: self energy - newForager energy.
			newForager moveTo: freePlace]</body>

<body package="ECEC" selector="updateEnergy">updateEnergy
	self energy: self energy - self class metabolicRate</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>accessing</category>

<body package="ECEC" selector="energy:">energy: aValue
energy := aValue</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>probes</category>

<body package="ECEC" selector="energy">energy
	"Getter accessor with default value = 50 "

	"energy isNil ifTrue:[energy := Cormas randomFrom: 1 to:  50]. "

	energy isNil 
		ifTrue: 
			[self class initEnergy = 50 
				ifTrue: [energy := 50]
				ifFalse: [energy := Cormas randomFrom: 1 to: 50]].
	^energy</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>pov</category>

<body package="ECEC" selector="pov">pov
"return a symbol or a ColorValue"
^self class name</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>control</category>

<body package="ECEC" selector="step">step
	self updateEnergy.
	self move.
	self eat.
	self reproduce.
	self die</body>
</methods>


<class>
<name>UnrestrainedForager</name>
<environment>CormasNS.Models.ECEC</environment>
<super>CormasNS.Models.ECEC.Forager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ECEC Category</category>
<attributes>
<package>ECEC</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.UnrestrainedForager class</class-id> <category>accessing</category>

<body package="ECEC" selector="harvestRate">harvestRate
	"Getter accessor with default value = 0.99 "
	harvestRate isNil ifTrue:[harvestRate := 0.99]. 
	^harvestRate</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.UnrestrainedForager</class-id> <category>init</category>

<body package="ECEC" selector="init">init
	"to be completed. The inherited attributes should have been already initialized"</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.UnrestrainedForager</class-id> <category>pov</category>

<body package="ECEC" selector="pov">pov
"return a symbol or a ColorValue"
^super pov</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.UnrestrainedForager</class-id> <category>probes</category>

<body package="ECEC" selector="energy">energy

	^super energy</body>
</methods>


<class>
<name>RestrainedForager</name>
<environment>CormasNS.Models.ECEC</environment>
<super>CormasNS.Models.ECEC.Forager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ECEC Category</category>
<attributes>
<package>ECEC</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.RestrainedForager class</class-id> <category>accessing</category>

<body package="ECEC" selector="harvestRate">harvestRate
	"Getter accessor with default value = 0.5 "
	harvestRate isNil ifTrue:[harvestRate := 0.5]. 
	^harvestRate</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.RestrainedForager</class-id> <category>pov</category>

<body package="ECEC" selector="pov">pov
"return a symbol or a ColorValue"
^super pov</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.RestrainedForager</class-id> <category>probes</category>

<body package="ECEC" selector="energy">energy

	^super energy</body>
</methods>



</st-source>
