'From VisualWorks® NonCommercial, Release 7 of June 14, 2002 on June 19, 2003 at 8:16:41 am'!


CormasNS.Models defineNameSpace: #TSE
	private: false
	imports: '
			private Smalltalk.*
			private CormasNS.Kernel.*
			'
	category: 'TSECategory'!


CormasNS.Models.TSE defineClass: #Cell
	superclass: #{CormasNS.Kernel.SpatialEntityElement}
	indexedType: #none
	private: false
	instanceVariableNames: 'seed context '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-TSE'!

CormasNS.Models.TSE.Cell defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.TSE.Cell class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.TSE.Cell methodsFor: 'pov'!

povContext
	(self context notNil and: [self context isKindOf: Number])
		ifTrue: [^ColorValue constantNames at: self context]
		ifFalse: [^#empty]!

povSeed
	self isSeed ifTrue: [^#seed].
	(self theCSE notNil and: [self isComponentOf: Aggregate])
		ifTrue: [^self colorOfNumber: (self theCSE at: #Aggregate) id]
		ifFalse: [^#empty]!

povSeedAB
	self seed = #a ifTrue: [^#seedA].
	self seed = #b ifTrue: [^#seedB].!

povTree
	self context isNil ifTrue: [^#empty].
	self seed isNil ifTrue: [^#dead].
	self seed = 0 ifTrue: [^#surround].
	self seed ifTrue: [^#seed] ifFalse: [^self context	"^#tree"]! !

!CormasNS.Models.TSE.Cell methodsFor: 'control'!

forestSurroundingRatio
	^(self neighbourhood select: [:n | n isAggregated]) size
		/ self neighbourhood size! !

!CormasNS.Models.TSE.Cell methodsFor: 'testing'!

isAggregated
	^self theCSE notNil and: 
			[(self theCSE includesKey: #Aggregate)
				and: [(self theCSE at: #Aggregate) notNil]]!

isSeed
^self seed = true!

isTree
	^self context = #tree! !

!CormasNS.Models.TSE.Cell methodsFor: 'init'!

init
	super init.
	self seed: false!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.TSE.Cell methodsFor: 'accessing'!

context
	^context!

context: anObject
	context := anObject.
	self defineVisualState; show!

seed
^seed!

seed: aValue 
	seed := aValue.
	self defineVisualState; show! !


CormasNS.Models.TSE defineClass: #Aggregate
	superclass: #{CormasNS.Kernel.SpatialEntityAggregate}
	indexedType: #none
	private: false
	instanceVariableNames: ''
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-TSE'!

CormasNS.Models.TSE.Aggregate defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.TSE.Aggregate class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.TSE.Aggregate methodsFor: 'pov'!

povId
	^super povId!

povSize
self components size < 100 ifTrue: [^#small].
self components size < 200 ifTrue: [^#medium].
self components size >= 200 ifTrue: [^#big].! !

!CormasNS.Models.TSE.Aggregate methodsFor: 'control'!

expand
	| collec |
	collec := self setSurround
				asSortedCollection: [:a :b | a forestSurroundingRatio > b forestSurroundingRatio].
	1 to: (self size / 100) asInteger do: [:i | (collec at: i) context: #tree; seed: 0]! !

!CormasNS.Models.TSE.Aggregate methodsFor: 'init'!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !


CormasNS.Models.TSE defineClass: #TSE
	superclass: #{CormasNS.Kernel.CormasModel}
	indexedType: #none
	private: false
	instanceVariableNames: 'theCells theAggregates seeds partitionsAverageSize nbCells '
	classInstanceVariableNames: ''
	imports: ''
	category: 'Cormas-TSE'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.TSE.TSE class methodsFor: 'description'!

aboutIt
	| txt |
	txt := 'This model introduces the functionning principles of Cormas aggregative spatial entities. In the inheritage tree of the Cormas generic spatial entities, the compound spatial entity SpatialEntity_Set is specialized in :
      	* SpatialEntityAggregate  whose components should be contiguous
   		* SpatialEntityNotConnex  whose components may not be contiguous.

The operations of aggregation-disintegration are based on the two attributes components (a collection of lower level spatial entities) and theCSE (a register of belonging to higer level spatial entities). 
 
The TSE model is a didactic model that allows to test two different ways to create spatial aggregates with Cormas. 

In the first one, the components are defined as sets of contiguous cells sharing a same condition. The first step is to load a spatial grid made of 50*50 cells (instances of the Cell class) from a file. Each cell has either #tree (aggregation condition) or #empty as value of its context attribute. The effective instanciations from the compound spatial entity Aggregate are submitted to an additional constraint about a minimum number (set to 25) of contiguous components verifying the aggregation condition. To let co-exist in the same model several spatial entities defined at different levels gives a great flexibility to write the dynamics of the model. Some of the processes are more easily described at the cellular level, as for some others, the aggregated level is more suitable. In this didactic and simplistic example, each cell has a fixed (very low) probability to switch its context attribute value. At the level of the aggregates, a spreading process from the edges is written like this: a given number (corresponding to the hundredth of the total number of components of the forestry entity) of cells at the outside edge are going to be aggregated to the forest. In order to keep a high compacity to the forestry entities, a priority is given to the cells that are surrounded by the highest number of already aggregated cells. 
      
In the second one, 10 seed cells are randomly chosen in the 50*50 spatial grid. 10 aggregates are intialized with one of these seeds as a single component. The iterative building process of the aggregates relies on the integration, among the cells belonging to the outside edge of each aggregate, of all the one that do not yet belong to another aggregate'
				asText emphasizeAllWith: #(#bold).
	ComposedTextView open: txt asValue
		label: 'About ' , self name
		icon: (Icon constantNamed: #workspace)
		extent: 600 @ 600!

aProposDe
	| txt |
	txt := 'Ce modele illustre les principes d''utilisation des entites spatiales agregatives de Cormas. Dans l''arbre d''heritage des entites spatiales generiques de Cormas, l''entite spatiale composee SpatialEntity_Set se specialise :
      * SpatialEntityAggregate  dont les composants respectent une contrainte de contiguite
      * SpatialEntityNotConnex  dont les composants peuvent etre disjoints.

Les operations d''agregation-desagregation sont realisees a partir des deux attributs, components        (une collection d''entites spatiales de niveau hierarchique inferieur) et theCSE (un registre d''appartenance a des entites spatiales de niveaux superieurs). 

Le modele TSE permet de tester deux facons de creer des agregats avec Cormas.

La premiere consiste a definir les composantes comme des ensembles de cellules contigues partageant une meme condition. On commence par charger une grille de 50*50 cellules de type Cell dont l''attribut context est soit #forest (condition d''agregation), soit #empty. La creation des entites spatiales composees Aggregate est soumise a une contrainte supplementaire sur le nombre minimum (fixe a 25) de composants contigus verifiant la condition d''agregation. Faire co-exister dans le meme modele des entites spatiales definies a differents niveaux offre une grande souplesse pour ecrire les methodes de dynamique de la vegetation. Certains processus seront plus facilement decrits au niveau cellulaire, d''autres au niveau agrege. Ainsi, dans cet exemple theorique simpliste, chaque cellule a une probabilite fixee (tres faible) de changer de contexte. Une dynamique d''expansion par la lisiere est ecrite (au niveau agrege) de la facon suivante: un certain nombre (correspondant au centieme du total des cellules composants l''entite forestiere) de cellules en lisiere vont etre integrees a la foret. Dans le but de garder une certaine compacite aux entites forestieres, on choisit en priorite les cellules de la lisiere qui sont entourees du plus grand nombre de cellules deja agregees. 

La seconde consiste a partir de 10 cellules graines, et a creer autant d''agregats initialement constitues  d''un seul composant: une graine. Le processus iteratif de construction des agregats repose sur l''integration, parmi les cellules en lisiere, de toutes celles qui n''appartiennent pas encore a un autre agregat.'
				asText emphasizeAllWith: #(#bold).
	ComposedTextView open: txt asValue
		label: 'About ' , self name
		icon: (Icon constantNamed: #workspace)
		extent: 600 @ 600!

howToRunIt
| txt |
txt := '1. Spreading of 3 forests\' withCRs asText emphasizeAllWith: #(#bold #large).
txt := txt, '1.1 From the Cormas main menu, load ' asText, ('Files -> Load ' asText emphasizeAllWith: #italic), '. Select ' asText, ('TSE ' asText emphasizeAllWith: #italic), 'and choose ' asText, ('SpreadForest.st ' asText emphasizeAllWith: #color -> ColorValue red), ' version of TSE.\' withCRs asText.
txt := txt, '1.2 Click on the first icon of the ' asText, ('Visualisation ' asText emphasizeAllWith: #color -> ColorValue red), 'area to open the standard spatial grid.\' withCRs asText.
txt := txt, '1.3 From the spatial grid menu, use ' asText, ('Tools -> Load an environment' asText emphasizeAllWith: #italic), ', select ' asText, ('3forests.env ' asText emphasizeAllWith: #italic), 'and validate. This will initialize a 50*50 grid and assign values (#tree or #empty) to the cell attribute ' asText, ('context\' withCRs asText emphasizeAllWith: #italic).
txt := txt, '1.4 Right-click within the spatial grid window to select the ' asText, ('povTree ' asText emphasizeAllWith: #italic), 'view for ' asText, ('Cell' asText emphasizeAllWith: #italic), '.\' withCRs asText.
txt := txt, '1.5 Click on the ' asText, ('Initialize ' asText emphasizeAllWith: #italic), 'button of the ' asText, ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\' withCRs asText.
txt := txt, '1.6 Select the ' asText, ('initForests ' asText emphasizeAllWith: #italic), 'and ' asText, ('stepForests: ' asText emphasizeAllWith: #italic), 'methods, then validate by clicking on ' asText, ('Apply and close.' asText emphasizeAllWith: #italic), ' This version builds first level Aggregates (the forests are composed of connected cells with #forest as context) and second level aggregates : a fragmented aggregate composed with first level aggregates.\'  withCRs asText.
txt := txt, '1.7 Right-click within the spatial grid window to select the ' asText, ('povSize ' asText emphasizeAllWith: #italic), 'view for ' asText, ('Aggregate' asText emphasizeAllWith: #italic), '.\' withCRs asText.
txt := txt, '1.8 Enter 30 in the ' asText, ('Final time ' asText emphasizeAllWith: #italic), 'input field of the ' asText,  ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\' withCRs asText.
txt := txt, '1.9 Click on the ' asText, ('Run ' asText emphasizeAllWith: #italic), 'button of the ' asText,  ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\\' withCRs asText.

txt := txt, ('2. Swelling from 10 seeds\' withCRs asText emphasizeAllWith: #(#bold #large)).
txt := txt, '2.1 From the spatial grid menu, use ' asText, ('Tools -> Load an environment' asText emphasizeAllWith: #italic), ', select ' asText, ('10seeds.env ' asText emphasizeAllWith: #italic), 'and validate. This will initialize a 50*50 grid and assign values (true or false) to the cell attribute ' asText, ('seed\' withCRs asText emphasizeAllWith: #italic).
txt := txt, '2.2 Right-click within the spatial grid window to select the ' asText, ('povSeed ' asText emphasizeAllWith: #italic), 'view for ' asText, ('Cell' asText emphasizeAllWith: #italic), '.\' withCRs asText.
txt := txt, '2.3 Click on the ' asText, ('Initialize ' asText emphasizeAllWith: #italic), 'button of the ' asText, ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\' withCRs asText.
txt := txt, '2.4 Select the ' asText, ('initSeeds ' asText emphasizeAllWith: #italic), 'and ' asText, ('stepSeeds: ' asText emphasizeAllWith: #italic), 'methods, then validate by clicking on ' asText, ('Apply and close.\' asText emphasizeAllWith: #italic) withCRs asText.
txt := txt, '2.5 Right-click within the spatial grid window to select the ' asText, ('povId ' asText emphasizeAllWith: #italic), 'view for ' asText, ('Aggregate' asText emphasizeAllWith: #italic), '.\' withCRs asText.
txt := txt, '2.6 Click on the ' asText, ('Step ' asText emphasizeAllWith: #italic), 'button of the ' asText,  ('Simulation ' asText emphasizeAllWith: #color -> ColorValue red),  'area.\\' withCRs asText.
txt := txt, ('3. Save and load your environment\' withCRs asText emphasizeAllWith: #(#bold #large)).
txt := txt, '3.1 From the Cormas main menu, load ' asText, ('Files -> Load ' asText emphasizeAllWith: #italic), '. Select ' asText, ('TSE ' asText emphasizeAllWith: #italic), 'and choose ' asText, ('Save-Load-Aggregates.st ' asText emphasizeAllWith: #color -> ColorValue red), ' version of TSE.\' withCRs asText.
txt := txt, '3.2 The init method will load a 50*50 grid and load the aggregate instances and their neighbours.\' withCRs asText.
txt := txt, '3.2 If you want to see how to save the current grid, the aggregates and their neighbours, see the ' asText, ('exportAggregatesAndNeighbours:' asText emphasizeAllWith: #italic), ' method. (You can also save the neighbours of the cells. It can save time when you load big irregular grid (see the ' asText, ('exportNeighboors' asText emphasizeAllWith: #italic), ' method).\' withCRs asText.
ComposedTextView open: txt asValue label: ('How to run ', self name, '     step-by-step instructions') icon: (Icon constantNamed: #workspace) extent: 530@550! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.TSE.TSE methodsFor: 'procedures'!

buildForests
	self spaceModel
		setAggregates: Aggregate
		from: Cell
		verifying: [:c | c context = #tree]
		minimumSize: 25.
	self theAggregates do: [:agg | agg initNeighbourhood].
	self spaceModel meanCompactness: Aggregate!

importForests
	self spaceModel 
		importAggregateClass: Aggregate
		componentClass: Cell
		separator: $;! !

!CormasNS.Models.TSE.TSE methodsFor: 'seeds'!

givenSeeds
"set 5 particular seeds on the space : central location, upper right and left location, lower right and left locations"
	self seeds: OrderedCollection new.
	self seeds add: self spaceModel centralLocation;
		add: self spaceModel upperRightLocation;
		add: self spaceModel upperLeftLocation;
		add: self spaceModel lowerRightLocation;
		add: self spaceModel lowerLeftLocation.
	self seeds do: [:c | c seed: true].
	^self seeds!

randomSeeds: n
	"Spreads randomly n seeds on the space"

	| newSeed |
	self seeds: OrderedCollection new.
	[self seeds size < n]
		whileTrue: 
			[newSeed := Cormas selectRandomlyFrom: self theCells.
			(self seeds includes: newSeed)
				ifFalse: 
					[self seeds add: newSeed.
					newSeed seed: true]].
	^self seeds! !

!CormasNS.Models.TSE.TSE methodsFor: 'init'!

setAggregatesFifthFourth
	"Constructs a complete space partition by regular segmentation : 4 lines and 5 colomns"

	self spaceModel loadEnvironmentFromFile: ((Cormas mapsPath: self class name)
			construct: 'partitions.env').
	self spaceModel setAggregates: Aggregate from: Cell horizontalDividers: 5 verticalDividers: 4.
	self spaceModel refreshViewOnSpatialEntity: Aggregate activePov: #povId.!

setAggregatesFromGivenSeeds
	"Constructs 5 aggregates from 5 given seeds. The size of each aggregate should be equal to :
	15 , 105, 210, 315 and 1200, but because of the lack of space, the size of the last aggregat is equal to 1036.
	The point of view is automaticaly set and the size of each aggregat is displayed on the grid"

	self spaceModel loadEnvironmentFromFile: ((Cormas mapsPath: self class name)
			construct: 'partitions.env').
	self spaceModel
		setAggregates: Aggregate
		fromSeeds: self givenSeeds
		sizeDistribution: #(#(1 15) #(1 105) #(1 210) #(1 315) #(1 1200)).
	self spaceModel refreshViewOnSpatialEntity: Aggregate activePov: #povId.
	self theAggregates do: [:a| a displayString: a size printString ].!

setAggregatesFromRandomSeeds
	"Constructs a complete space partition from seeds"
	"Constructs 6 aggregates from 6 random seeds.
	The point of view is automaticaly set and the size of each aggregat is displayed on the grid"

	self spaceModel loadEnvironmentFromFile: ((Cormas mapsPath: self class name)
			construct: 'partitions.env').
	self spaceModel
		setAggregates: Aggregate
		fromSeeds: (self randomSeeds: 6).
	self spaceModel refreshViewOnSpatialEntity: Aggregate activePov: #povId.
	self theAggregates do: [:a| a displayString: a size printString ]!

setAggregatesFromRandomSeedsDistribution
	"Constructs a space partition from seeds"
	"Constructs 6 aggregates from 6 random seeds. The size of each aggregate should be equal to :
	250 for the 2 firsts , 110 for the two seconds and 25 for the two lasts.
	The point of view is automaticaly set and the size of each aggregat is displayed on the grid"

	self spaceModel loadEnvironmentFromFile: ((Cormas mapsPath: self class name)
			construct: 'partitions.env').
	self spaceModel
		setAggregates: Aggregate
		fromSeeds: (self randomSeeds: 6).
	self spaceModel refreshViewOnSpatialEntity: Aggregate activePov: #povId.
	self theAggregates do: [:a| a displayString: a size printString ]!

setSingletonAggregatesFromRandomSeeds
	"Constructs 30 aggregates made of a single component from 30 random seeds."
	self spaceModel loadEnvironmentFromFile: ((Cormas mapsPath: self class name)
			construct: 'partitions.env').
	self theCells do:[:c| c context: nil].
	self spaceModel
		setSingletonAggregates: Aggregate
		fromSeeds: (self randomSeeds: 30).
	self spaceModel refreshViewOnSpatialEntity: Aggregate activePov: #povId.! !

!CormasNS.Models.TSE.TSE methodsFor: 'control'!

swellAggregates: t  
	self spaceModel swell: Aggregate! !

!CormasNS.Models.TSE.TSE methodsFor: 'accessing'!

seeds
	"Getter accessor without default value "
	^seeds!

seeds: anObject 
	seeds := anObject!

theAggregates
	^theAggregates!

theAggregates: x 
	theAggregates := x!

theCells
	^theCells!

theCells: x 
	theCells := x! !


